Do not require clean tree when reverting and cherry-picking.
[git/git.git] / git-merge.sh
CommitLineData
91063bbc
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
6. git-sh-setup || die "Not a git archive"
7
8LF='
9'
10
11usage () {
12 die "git-merge [-n] [-s <strategy>]... <merge-message> <head> <remote>+"
13}
14
e4cf17ce 15# all_strategies='resolve recursive stupid octopus'
91063bbc 16
e4cf17ce 17all_strategies='recursive octopus resolve stupid'
2276aa6c 18default_strategies='resolve octopus'
91063bbc
JH
19use_strategies=
20
a9358240
JH
21dropsave() {
22 rm -f -- "$GIT_DIR/MERGE_HEAD" \
23 "$GIT_DIR/MERGE_SAVE" || exit 1
24}
25
26savestate() {
27 git diff -r -z --name-only $head | cpio -0 -o >"$GIR_DIR/MERGE_SAVE"
28}
29
30restorestate() {
31 git reset --hard $head
32 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
33 git-update-index --refresh >/dev/null
91063bbc
JH
34}
35
36summary() {
37 case "$no_summary" in
38 '')
39 git-diff-tree -p -M $head "$1" |
40 git-apply --stat --summary
41 ;;
42 esac
43}
44
45while case "$#" in 0) break ;; esac
46do
47 case "$1" in
48 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
49 --no-summa|--no-summar|--no-summary)
50 no_summary=t ;;
51 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
52 --strateg=*|--strategy=*|\
53 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
54 case "$#,$1" in
55 *,*=*)
56 strategy=`expr "$1" : '-[^=]*=\(.*\)'` ;;
f88ed172 57 1,*)
91063bbc
JH
58 usage ;;
59 *)
60 strategy="$2"
61 shift ;;
62 esac
63 case " $all_strategies " in
64 *" $strategy "*)
65 use_strategies="$use_strategies$strategy " ;;
66 *)
67 die "available strategies are: $all_strategies" ;;
68 esac
69 ;;
70 -*) usage ;;
71 *) break ;;
72 esac
73 shift
74done
75
76case "$use_strategies" in
77'')
78 use_strategies=$default_strategies
79 ;;
80esac
81test "$#" -le 2 && usage ;# we need at least two heads.
82
83merge_msg="$1"
84shift
8cc01e50 85head_arg="$1"
91063bbc
JH
86head=$(git-rev-parse --verify "$1"^0) || usage
87shift
88
89# All the rest are remote heads
90for remote
91do
92 git-rev-parse --verify "$remote"^0 >/dev/null ||
93 die "$remote - not something we can merge"
94done
95
96common=$(git-show-branch --merge-base $head "$@")
97echo "$head" >"$GIT_DIR/ORIG_HEAD"
98
99case "$#,$common" in
100*,'')
8cc01e50 101 die "Unable to find common commit between $head_arg and $*"
91063bbc
JH
102 ;;
1031,"$1")
104 # If head can reach all the merge then we are up to date.
105 # but first the most common case of merging one remote
106 echo "Already up-to-date. Yeeah!"
a9358240 107 dropsave
91063bbc
JH
108 exit 0
109 ;;
1101,"$head")
111 # Again the most common case of merging one remote.
112 echo "Updating from $head to $1."
113 git-update-index --refresh 2>/dev/null
114 git-read-tree -u -m $head "$1" || exit 1
115 git-rev-parse --verify "$1^0" > "$GIT_DIR/HEAD"
116 summary "$1"
a9358240 117 dropsave
91063bbc
JH
118 exit 0
119 ;;
1201,*)
121 # We are not doing octopus and not fast forward. Need a
122 # real merge.
123 ;;
124*)
125 # An octopus. If we can reach all the remote we are up to date.
126 up_to_date=t
127 for remote
128 do
129 common_one=$(git-merge-base $head $remote)
130 if test "$common_one" != "$remote"
131 then
132 up_to_date=f
133 break
134 fi
135 done
136 if test "$up_to_date" = t
137 then
138 echo "Already up-to-date. Yeeah!"
a9358240 139 dropsave
91063bbc
JH
140 exit 0
141 fi
142 ;;
143esac
144
a9358240
JH
145# At this point, we need a real merge. No matter what strategy
146# we use, it would operate on the index, possibly affecting the
147# working tree, and when resolved cleanly, have the desired tree
148# in the index -- this means that the index must be in sync with
149# the $head commit.
150files=$(git-diff-index --cached --name-only $head) || exit
151if [ "$files" ]; then
152 echo >&2 "Dirty index: cannot merge (dirty: $files)"
153 exit 1
154fi
91063bbc 155
a9358240
JH
156case "$use_strategies" in
157?*' '?*)
158 # Stash away the local changes so that we can try more than one.
159 savestate
160 single_strategy=no
161 ;;
162*)
163 single_strategy=yes
164 ;;
165esac
91063bbc
JH
166
167result_tree= best_cnt=-1 best_strategy= wt_strategy=
168for strategy in $use_strategies
169do
170 test "$wt_strategy" = '' || {
171 echo "Rewinding the tree to pristine..."
a9358240 172 restorestate
91063bbc 173 }
a9358240
JH
174 case "$single_strategy" in
175 no)
176 echo "Trying merge strategy $strategy..."
177 ;;
178 esac
179
180 # Remember which strategy left the state in the working tree
91063bbc 181 wt_strategy=$strategy
a9358240
JH
182
183 git-merge-$strategy $common -- "$head_arg" "$@" || {
91063bbc
JH
184
185 # The backend exits with 1 when conflicts are left to be resolved,
186 # with 2 when it does not handle the given merge at all.
187
188 exit=$?
189 if test "$exit" -eq 1
190 then
191 cnt=`{
192 git-diff-files --name-only
193 git-ls-files --unmerged
194 } | wc -l`
195 if test $best_cnt -le 0 -o $cnt -le $best_cnt
196 then
197 best_strategy=$strategy
198 best_cnt=$cnt
199 fi
200 fi
201 continue
202 }
203
204 # Automerge succeeded.
205 result_tree=$(git-write-tree) && break
206done
207
208# If we have a resulting tree, that means the strategy module
209# auto resolved the merge cleanly.
210if test '' != "$result_tree"
211then
212 parents="-p $head"
213 for remote
214 do
215 parents="$parents -p $remote"
216 done
217 result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree $parents)
218 echo "Committed merge $result_commit, made by $wt_strategy."
219 echo $result_commit >"$GIT_DIR/HEAD"
220 summary $result_commit
a9358240 221 dropsave
91063bbc
JH
222 exit 0
223fi
224
225# Pick the result from the best strategy and have the user fix it up.
226case "$best_strategy" in
227'')
a9358240 228 restorestate
91063bbc
JH
229 die "No merge strategy handled the merge."
230 ;;
231"$wt_strategy")
232 # We already have its result in the working tree.
233 ;;
234*)
235 echo "Rewinding the tree to pristine..."
a9358240 236 restorestate
91063bbc 237 echo "Using the $best_strategy to prepare resolving by hand."
a9358240 238 git-merge-$best_strategy $common -- "$head_arg" "$@"
91063bbc
JH
239 ;;
240esac
241for remote
242do
243 echo $remote
244done >"$GIT_DIR/MERGE_HEAD"
245die "Automatic merge failed; fix up by hand"